#include <QApplication>
#include <QWidget>
#include <QPainter>
#include <QDebug>

class MyWidget : public QWidget
{
public:
    MyWidget(QWidget *parent = 0) : QWidget(parent) {}
protected:
    void paintEvent(QPaintEvent *e)
    {
        Q_UNUSED(e);
        QPainter p(this);

        QPen MyPen(QColor(0,0,0));
        MyPen.setWidth (1);

        p.setBrush ( QColor(255, 200, 15) );
        p.setBackground( QColor(255, 200, 15) );
        p.setBackgroundMode( Qt::OpaqueMode );
        p.setPen(MyPen);

        QFont MyFont("Arial", 12);
        p.setFont(MyFont);

        QFontMetrics MyMetric(MyFont);
        int h = MyMetric.height();
        int w = MyMetric.width(QString("Hello"));

        p.drawText( QRect(20,40, w, h + 1), QString("Hello") );
        p.drawText( QRect(60,40, w, h), QString("Hello") );
        p.drawText( QRect(100,40, w, h - 1), QString("Hello") );

        p.drawLine( 50, 40 + h, 70, 40 + h );
        p.drawLine( 90, 40 + h, 110, 40 + h );
        p.drawLine( 120, 40 + h, 150, 40 + h );

        p.setPen(Qt::NoPen);
        p.drawRect( QRect(140,40, w, h) );

        QString sSizeInfo = QString("width = %1, height = %2").arg(w).arg(h);
        p.drawText( 20, 80, sSizeInfo );
    }
};

int main(int argc, char **argv)
{
    QApplication a(argc, argv);
    MyWidget w;

    w.show();
    return a.exec();
}
